;Disp.h
;compiled from multiple sources (mainly the online ZShell School)

PixOn:				;turns on pixel at b,c
	push	af
	push	bc
	push	de
	push	hl
	call	FindPixel

	ld	de,_drawScrn
	add	hl,de
	or	(hl)
	ld	(hl),a

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

PixOff:				;turns off pixel at b,c
	push	af
	push	bc
	push	de
	push	hl
	call	FindPixel

	ld	de,_drawScrn
	add	hl,de
	cpl
	and	(hl)
	ld	(hl),a

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

PixTog:				;toggles pixel at b,c
	push	af
	push	bc
	push	de
	push	hl
	call	FindPixel

	ld	de,_drawScrn
	add	hl,de
	xor	(hl)
	ld	(hl),a

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

PixTst:				;zf if b,c is off: nz if b,c is on
	push	bc
	push	de
	push	hl
	call	FindPixel

	ld	de,_drawScrn
	add	hl,de
	and	(hl)

	pop	hl
	pop	de
	pop	bc
	ret

PutImage:			; Puts the image stored at (HL) to b,c
	push	af
	push	bc
	push	de
	push	hl

	push	hl
	call	FindPixel
	ld	de, _drawScrn
	add	hl, de
	push	hl
	pop	de
	pop	hl

	ld	b,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
PI_NewRow:
	push	bc
	push	de
PI_NewCol:
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de
	djnz	PI_NewCol
	pop	de
	ld	bc,16
	ex	de,hl
	add	hl,bc
	ex	de,hl
	pop	bc
	dec	c
	jr	nz,PI_NewRow

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

; ASCR	- Advanced Sprite Clipping Routines
;
; 	by Jimmy Mrdell	970304	 Last update 970803
;
; Temporary variables needed:
;  clipmask  : Byte
;  rows2put  : Byte
;  bitmask	 : Byte
;
;
; PutSprite_MSB:
;  Puts an 8x8 sprite at coordinates B,C. HL should point to a bitmapped
;  sprite followed by a bitmapped mask, total 16 bytes. DE should point
;  to an a memory location where the background will be stored as a
;  bitmap (8 bytes). The sprite will be clipped.
;
; PutSprite:
;  Puts an 8x8 sprite at B,C. HL = pointer to sprite. No mask and no
;  background storage, just clipping.

clipmask:
	.db 0
rows2put:
	.db 0
bitmask:
	.db 0

PutSprite_MSB:		; BC = x,y	DE = background storage  HL = sprite + mask
 ld a,c
 cp 150
 jr nc,PMSB_NoBotClip
 cp 64
 ret nc
PMSB_NoBotClip:
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PMSB_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPMSB
 neg
 push bc
 ld b,a
 ld a,$FF
PMSB_LeftClip:
 srl a
 djnz PMSB_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PMSB_CheckBotClip
PMSB_CheckRightClip
 ld a,b
 sub 121
 jr c,PMSB_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PMSB_RightClip:
 add a,a
 djnz PMSB_RightClip
 ld (clipmask),a
 pop bc
PMSB_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PMSB_CheckTopClip
 bit 6,c
 jp nz,EndMSB
 ld a,64
 sub c
 cp 8
 jr nc,PMSB_ClippingDone
 ld (rows2put),a
 jr PMSB_ClippingDone
PMSB_CheckTopClip:
 ld a,c
 cp 249
EndPMSB:
 jr c,EndMSB
 ret c
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PMSB_TopClip:
 inc hl
 inc de
 djnz PMSB_TopClip
 pop bc
 ld c,0
PMSB_ClippingDone:
 di
 push iy
 push hl
 pop iy
 push de
 pop ix
 ld a,(rows2put)
 push af
 call FindPixel
Modify_5:
 ld de,_drawScrn
 add hl,de
 ld (bitmask),a
 pop bc
PMSB_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld a,(iy+8)
 and e
 ld e,a 	 ; e = mask for this row
 ld d,0 	 ; d = background for this row
 ld b,8 	 ; b = pixels left to put
 ld c,(iy) ; c = sprite row
 inc iy
PMSB_PutCol:
 push bc
 sla d
 ld a,(bitmask)
 and (hl)
 jr z,PMSB_NPH
 inc d
PMSB_NPH:
 rlc e
 jr nc,PMSB_NextBit
 ld a,(bitmask)
 rlc c
 jr c,PMSB_BitOn
 cpl
 and (hl)
 ld (hl),a
 jr PMSB_NextBit
PMSB_BitOn:
 or (hl)
 ld (hl),a
PMSB_NextBit:
 ld a,(bitmask)
 rrca
 ld (bitmask),a
 jr nc,PMSB_SSB
 inc hl
PMSB_SSB:
 pop bc
 rlc c
 djnz PMSB_PutCol
 ld (ix),d
 inc ix
 pop hl
 ld de,16
 add hl,de
 pop bc
 djnz PMSB_PutRow
 pop iy
 ei
EndMSB:
 pop ix
 pop hl
 pop de
 pop bc
 ret

PutSprite:		 ; BC = x,y  HL = sprite
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PSC_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPPS
 neg
 push bc
 ld b,a
 ld a,$FF
PSC_LeftClip:
 srl a
 djnz PSC_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PSC_CheckBotClip
PSC_CheckRightClip
 ld a,b
 sub 121
 jr c,PSC_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PSC_RightClip:
 add a,a
 djnz PSC_RightClip
 ld (clipmask),a
 pop bc
PSC_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PSC_CheckTopClip
 bit 6,c
 jr nz,EndPS
 ld a,64
 sub c
 cp 8
 jr nc,PSC_ClippingDone
 ld (rows2put),a
 jr PSC_ClippingDone
PSC_CheckTopClip:
 ld a,c
 cp 249
EndPPS:
 jr c,EndPS
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PSC_TopClip:
 inc hl
 inc de
 djnz PSC_TopClip
 pop bc
 ld c,0
PSC_ClippingDone:
 push hl
 pop ix
 ld a,(rows2put)
 push af
 call FindPixel
Modify_6:
 ld de,_drawScrn
 add hl,de
 ld d,a
 pop bc
PSC_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld b,8
 ld c,(ix)
 inc ix
PSC_PutCol:
 push bc
 rlc e
 jr nc,PSC_NextBit
 ld a,d
 rlc c
 jr c,PSC_BitOn
 cpl
 and (hl)
 ld (hl),a
 jr PSC_NextBit
PSC_BitOn:
 or (hl)
 ld (hl),a
PSC_NextBit:
 rrc d
 jr nc,PSC_SSB
 inc hl
PSC_SSB:
 pop bc
 rlc c
 djnz PSC_PutCol
 pop hl
 ld bc,16
 add hl,bc
 pop bc
 djnz PSC_PutRow
EndPS:
 pop ix
 pop hl
 pop de
 pop bc
 ret

; FASTLINE 1.0
;
; BRESENHAM'S LINE ALGORITHM
; by Jimmy Mrdell <yarin@acc.umu.se>
;
; Parameters:  BC    = memory area to draw line (usually $FC00)
;              DE,HL = coordinates of line (D,E)-(H,L)
;                      0 < D,H < 128, 0 < E,L < 64
;
; Code size:   145 bytes (excluding FindPixel)
;             
; Registers:   AF destroyed.
FLine:
	push bc
	push de
	push hl
	push bc
	ld a,h
	cp d
	jr nc,DXpos
	ex de,hl
DXpos:
	ld b,d
	ld c,e
	pop de
	push hl
	call FindPixel
	add hl,de
	ex (sp),hl
	ld e,c
	ld c,a
	ld a,h
	sub b
	ld b,a
	ld a,l
	sub e
	ld de,16
	jr nc,DYpos
	neg
	ld de,-16
DYpos:
	push af
	sub b
	jr nc,DY_Greater
	add a,a
	neg
	ld (x_ai+1),a
	pop af
	add a,a
	ld (XDNeg+1),a
	sub b
	pop hl
	push af
	ld a,c
	or (hl)
	ld (hl),a
	pop af
	bit 7,a
	jr nz,XDNeg
XNewRow:
	add hl,de
x_ai:
	sub 0
	push af
	rrc c
	jr nc,XNoWrap1
	inc hl
XNoWrap1:
	ld a,c
	or (hl)
	ld (hl),a
	pop af
	dec b
	jr z,LineDone
	jr nc,XNewRow
XDNeg:
	add a,0
	push af
	rrc c
	jr nc,XNoWrap2
	inc hl
XNoWrap2:
	ld a,c
	or (hl)
	ld (hl),a
	pop af
	dec b
	jr z,LineDone
	jr c,XNewRow
	jr XDNeg
DY_Greater:
	neg
	add a,a
	ld (YNoWrap+1),a
	ld a,b
	add a,a
	ld (YDNeg+1),a
	pop hl
	sub h
	ld b,h
	pop hl
	push af
	ld a,c
	or (hl)
	ld (hl),a
	pop af
YRepeat:
	bit 7,a
	jr nz,YDNeg
	rrc c
	jr nc,YNoWrap
	inc hl
YNoWrap:
	add a,0
	jr YPlot
YDNeg:
	add a,0
YPlot:
	add hl,de
	push af
	ld a,c
	or (hl)
	ld (hl),a
	pop af
	djnz YRepeat
LineDone:
	pop hl
	pop de
	pop bc
	ret

HLine:  ; this draws a line across the screen at C, using the patern in a
	push af
	push bc
	push de
	push hl

	ld b, 0
	call FindPixel
	ld de, _drawScrn
	add hl, de
	ld b, $10
HLLp:
	ld (hl), a
	inc hl
	djnz HLLp

	pop hl
	pop de
	pop bc
	pop af
	ret


;Taken from ascr.h
; 	by Jimmy Mrdell	970304	 Last update 970803
FindPixel:
	push	bc
	push	de
	ld	hl,ExpTable+1
	ld	d,0
	ld	a,b
	and	$07
	ld	e,a
	add	hl,de
	ld	e,(hl)
	ld	h,d
	srl	b
	srl	b
	srl	b
	ld	a,c
	add	a,a
	add	a,a
	ld	l,a
	add	hl,hl
	add	hl,hl
	ld	a,e
	ld	e,b
	add	hl,de
	pop	de
	pop	bc
	ret

;copied from Solytare
CopyGtoV:
	push	bc
	ld	hl, _plotSScreen
	ld	de, $FC00
	ld	bc, 1024
	ldir
	pop	bc
	ret

ExpTable:
 .db $01,$80,$40,$20,$10,$08,$04,$02,$01
